Ogre::GLSLESProgramPipelineManager Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state. More...

`#include <OgreGLSLESProgramPipelineManager.h>`

Inheritance diagram for Ogre::GLSLESProgramPipelineManager:
[legend]

List of all members.

## Public Member Functions

| GLSLESProgramPipelineManager (void)
| ~GLSLESProgramPipelineManager (void)
GLSLESProgramPipeline * | getActiveProgramPipeline (void)
| Get the program object that links the two active program objects together.
void | setActiveVertexLinkProgram (GLSLESGpuProgram *vertexGpuProgram)
| Set the active vertex and fragment link programs for the next rendering state.
void | setActiveFragmentLinkProgram (GLSLESGpuProgram *fragmentGpuProgram)
void | optimiseShaderSource (GLSLESGpuProgram *gpuProgram)
void | extractUniforms (GLuint programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &list)
| Populate a list of uniforms based on a program object.
void | extractConstantDefs (const String &src, GpuNamedConstants &constantDefs, const String &filename)
| Populate a list of uniforms based on GLSL ES source.

## Static Public Member Functions

static GLSLESProgramPipelineManager & | getSingleton (void)
static GLSLESProgramPipelineManager * | getSingletonPtr (void)

## Protected Types

typedef map< String, GLenum >::type | StringToEnumMap

## Protected Member Functions

void | completeDefInfo (GLenum gltype, GpuConstantDefinition &defToUpdate)
| Use type to complete other information.
bool | completeParamSource (const String &paramName, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReference &refToUpdate)
| Find where the data for a specific uniform should come from, populate.

## Protected Attributes

GLSLESGpuProgram * | mActiveVertexGpuProgram
| Active objects defining the active rendering gpu state.
GLSLESGpuProgram * | mActiveFragmentGpuProgram
StringToEnumMap | mTypeEnumMap
struct glslopt_ctx * | mGLSLOptimiserContext

## Static Protected Attributes

static GLSLESProgramPipelineManager * | msSingleton

## Private Types

typedef map< uint64, GLSLESProgramPipeline * > ::type | ProgramPipelineMap
typedef ProgramPipelineMap::iterator | ProgramPipelineIterator

## Private Attributes

ProgramPipelineMap | mProgramPipelines
| Container holding previously created program pipeline objects.
GLSLESProgramPipeline * | mActiveProgramPipeline
| Active objects defining the active rendering gpu state.

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state.

GLSL vertex and fragment program objects are compiled separately and then attached to a program object and then the program pipeline object is linked. Since Ogre can only handle one vertex program stage and one fragment program stage being active in a pass, the GLSL ES Program Pipeline Manager does the same. The GLSL ES Program Pipeline Manager acts as a state machine and activates a pipeline object based on the active vertex and fragment program. Previously created pipeline objects are stored along with a unique key in a hash_map for quick retrieval the next time the pipeline object is required.

Definition at line 48 of file OgreGLSLESProgramPipelineManager.h.

## Member Typedef Documentation

typedef ProgramPipelineMap::iterator Ogre::GLSLESProgramPipelineManager::ProgramPipelineIterator `[private]`

Definition at line 53 of file OgreGLSLESProgramPipelineManager.h.

typedef map<uint64, GLSLESProgramPipeline*>::type Ogre::GLSLESProgramPipelineManager::ProgramPipelineMap `[private]`

Definition at line 52 of file OgreGLSLESProgramPipelineManager.h.

typedef map<String, GLenum>::type Ogre::GLSLESProgramManagerCommon::StringToEnumMap `[protected, inherited]`

Reimplemented in Ogre::GLSLESLinkProgramManager.

Definition at line 61 of file OgreGLSLESProgramManagerCommon.h.

## Constructor & Destructor Documentation

Ogre::GLSLESProgramPipelineManager::GLSLESProgramPipelineManager | ( | void |  | ) |

Ogre::GLSLESProgramPipelineManager::~GLSLESProgramPipelineManager | ( | void |  | ) |

## Member Function Documentation

void Ogre::GLSLESProgramManagerCommon::completeDefInfo | ( | GLenum | gltype,
|  | GpuConstantDefinition & | defToUpdate
| ) |  | `[protected, inherited]`

Use type to complete other information.

bool Ogre::GLSLESProgramManagerCommon::completeParamSource | ( | const String & | paramName,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReference & | refToUpdate
| ) |  | `[protected, inherited]`

Find where the data for a specific uniform should come from, populate.

void Ogre::GLSLESProgramManagerCommon::extractConstantDefs | ( | const String & | src,
|  | GpuNamedConstants & | constantDefs,
|  | const String & | filename
| ) |  | `[inherited]`

Populate a list of uniforms based on GLSL ES source.

Parameters:

  src | Reference to the source code
  list | The defs to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).
  filename | The file name this came from, for logging errors.

void Ogre::GLSLESProgramManagerCommon::extractUniforms | ( | GLuint | programObject,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReferenceList & | list
| ) |  | `[inherited]`

Populate a list of uniforms based on a program object.

Parameters:

  programObject | Handle to the program object to query
  vertexConstantDefs | Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program.
  fragmentConstantDefs | Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program.
  list | The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).

GLSLESProgramPipeline* Ogre::GLSLESProgramPipelineManager::getActiveProgramPipeline | ( | void |  | ) |

Get the program object that links the two active program objects together.

If a program pipeline object was not already created and linked a new one is created and linked.

static GLSLESProgramPipelineManager& Ogre::GLSLESProgramPipelineManager::getSingleton | ( | void |  | ) | `[static]`

Reimplemented from Ogre::Singleton< GLSLESProgramPipelineManager >.

static GLSLESProgramPipelineManager* Ogre::GLSLESProgramPipelineManager::getSingletonPtr | ( | void |  | ) | `[static]`

Reimplemented from Ogre::Singleton< GLSLESProgramPipelineManager >.

void Ogre::GLSLESProgramManagerCommon::optimiseShaderSource | ( | GLSLESGpuProgram * | gpuProgram | ) | `[inherited]`

void Ogre::GLSLESProgramPipelineManager::setActiveFragmentLinkProgram | ( | GLSLESGpuProgram * | fragmentGpuProgram | ) |

void Ogre::GLSLESProgramPipelineManager::setActiveVertexLinkProgram | ( | GLSLESGpuProgram * | vertexGpuProgram | ) |

Set the active vertex and fragment link programs for the next rendering state.

The active program pipeline object will be cleared. Normally called from the GLSLESGpuProgram::bindProgram and unbindProgram methods

## Member Data Documentation

GLSLESGpuProgram* Ogre::GLSLESProgramManagerCommon::mActiveFragmentGpuProgram `[protected, inherited]`

Definition at line 59 of file OgreGLSLESProgramManagerCommon.h.

GLSLESProgramPipeline* Ogre::GLSLESProgramPipelineManager::mActiveProgramPipeline `[private]`

Active objects defining the active rendering gpu state.

Definition at line 59 of file OgreGLSLESProgramPipelineManager.h.

GLSLESGpuProgram* Ogre::GLSLESProgramManagerCommon::mActiveVertexGpuProgram `[protected, inherited]`

Active objects defining the active rendering gpu state.

Definition at line 58 of file OgreGLSLESProgramManagerCommon.h.

struct glslopt_ctx* Ogre::GLSLESProgramManagerCommon::mGLSLOptimiserContext `[protected, inherited]`

Definition at line 64 of file OgreGLSLESProgramManagerCommon.h.

ProgramPipelineMap Ogre::GLSLESProgramPipelineManager::mProgramPipelines `[private]`

Container holding previously created program pipeline objects.

Definition at line 56 of file OgreGLSLESProgramPipelineManager.h.

GLSLESProgramPipelineManager * Ogre::Singleton< GLSLESProgramPipelineManager >::msSingleton `[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

StringToEnumMap Ogre::GLSLESProgramManagerCommon::mTypeEnumMap `[protected, inherited]`

Reimplemented in Ogre::GLSLESLinkProgramManager.

Definition at line 62 of file OgreGLSLESProgramManagerCommon.h.

The documentation for this class was generated from the following file:

- OgreGLSLESProgramPipelineManager.h

Copyright © 2012 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun Sep 2 2012 07:28:04